---
title: Window.setImmediate()
slug: Web/API/Window/setImmediate
tags:
  - API
  - HTML DOM
  - Method
  - Non-standard
  - Reference
  - Window
  - setImmediate
---
<div>{{APIRef("HTML DOM")}}{{Non-standard_header}}</div>

<p>This method is used to break up long running operations and run a callback function immediately after the browser has completed other operations such as events and display updates.</p>

<div class="note">This method is not expected to become standard, and is only implemented by recent builds of Internet Explorer and Node.js 0.10+. It meets resistance both from <a href="https://bugzilla.mozilla.org/show_bug.cgi?id=686201">Gecko</a> (Firefox) and <a href="http://code.google.com/p/chromium/issues/detail?id=146172">Webkit</a> (Google/Apple).</div>

<h2 id="Syntax">Syntax</h2>

<pre class="syntaxbox">var <em>immediateID</em> = setImmediate(<em>func</em>, [<em>param1</em>, <em>param2</em>, ...]);
var <em>immediateID</em> = setImmediate(<em>func</em>);
</pre>

<ul>
 <li>where <code>immediateID</code> is the ID of the immediate which can be used later with {{DOMxRef("window.clearImmediate")}}.</li>
 <li><code>func</code> is the function you wish to call.</li>
</ul>

<p>All parameters will be passed directly to your function.</p>

<h2 id="Notes">Notes</h2>

<p>The {{DOMxRef("Window.clearImmediate", "clearImmediate")}} method can be used to clear the immediate actions, just like {{DOMxRef("Window.clearTimeout", "clearTimeout")}} for {{DOMxRef("window.setTimeout", "setTimeout")}}.</p>

<p>This method can be used instead of the <code>setTimeout(fn, 0)</code> method to execute <a href="http://www.nczonline.net/blog/2009/08/11/timed-array-processing-in-javascript/">heavy operations</a>. </p>

<p>The feature can be emulated in a few different ways:</p>

<ul>
 <li><span style="line-height: 22px;">{{DOMxRef("Window.postMessage", "postMessage")}} </span>can be used to trigger an immediate but yielding callback. Do note that Internet Explorer 8 includes a synchronous version of <code>postMessage</code>, which means it cannot be used as a fallback.</li>
 <li>{{DOMxRef("MessageChannel")}} can be used reliably inside of Web Workers whereas the semantics of postMessage mean it cannot be used there.</li>
 <li><code>setTimeout(fn, 0)</code> <em>can</em> potentially be used, however as it is clamped to 4ms for timers nested more than 5 levels deep <a href="https://html.spec.whatwg.org/multipage/webappapis.html#timers" title="http://www.whatwg.org/specs/web-apps/current-work/multipage/timers.html#dom-windowtimers-settimeout">per the HTML spec</a>, it does not make for a suitable polyfill for the natural immediacy of <code>setImmediate</code>.</li>
</ul>

<p>All of these techniques are incorporated into a <a href="https://github.com/NobleJS/setImmediate">robust setImmediate polyfill</a>.</p>

<h2 id="Specifications">Specifications</h2>

<table class="standard-table">
 <thead>
  <tr>
   <th scope="col">Specification</th>
   <th scope="col">Status</th>
   <th scope="col">Comment</th>
  </tr>
 </thead>
 <tbody>
  <tr>
   <td><a class="external" href="https://w3c.github.io/setImmediate/#si-setImmediate" hreflang="en" lang="en">Efficient Script Yielding<br>
    <small lang="en-US">The definition of '<code>setImmediate</code>' in that specification.</small></a></td>
   <td><span class="spec-ED">Editor's Draft</span></td>
   <td>Initial definition.</td>
  </tr>
 </tbody>
</table>

<h2 id="Browser_compatibility">Browser compatibility</h2>

<p>{{Compat("api.Window.setImmediate")}}</p>

<h2 id="See_also">See also</h2>

<ul>
 <li>{{DOMxRef("Window.clearImmediate()")}}</li>
 <li><a class="external" href="http://ie.microsoft.com/testdrive/Performance/setImmediateSorting/Default.html">Microsoft <code>setImmediate</code> API Demo</a></li>
</ul>
